# PRTG Custom DNS Monitoring Script

Dieses Skript ermöglicht es, DNS-Records (A, AAAA, MX, TXT, CNAME, NS) über PRTG zu überwachen. Es nutzt PowerShell zur DNS-Abfrage über einen spezifischen Nameserver und liefert die Ergebnisse im PRTG-XML-Format zurück.

## 📌 Funktionen
✅ Unterstützt verschiedene DNS-Record-Typen: A, AAAA, MX, TXT, CNAME, NS  
✅ Überprüfung eines spezifischen Nameservers  
✅ Fehlererkennung bei nicht erreichbaren Nameservern oder fehlenden DNS-Records  
✅ Ausgabe im PRTG-kompatiblen XML-Format  
✅ Anpassbare Parameter für flexible Nutzung  

## 🛠 Einrichtung in PRTG
### 1️⃣ Skript speichern
Speichere die Datei als **`CustomDNSCheck.ps1`** unter:
```plaintext
C:\Program Files (x86)\PRTG Network Monitor\Custom Sensors\EXEXML\
```

### 2️⃣ Neuen Sensor in PRTG erstellen
1. **Neuen Sensor hinzufügen**
2. **Sensor-Typ:** `EXE/Script Advanced`
3. **Skript auswählen:** `CustomDNSCheck.ps1`
4. **Parameter hinzufügen:**
   ```
   -Domain "mail.techniverse.net" -RecordType "MX" -DNSServer "ns1.your-server.de"
   ```
5. **Sensor speichern & testen**

### 3️⃣ Alternative: Platzhalter für dynamische DNS-Server
Falls du den DNS-Server aus dem Gerät übernehmen möchtest:
```plaintext
-Domain "mail.techniverse.net" -RecordType "MX" -DNSServer "%host"
```

## 🚦 Wann wird der Sensor rot?
🔴 **Sensor wird rot, wenn:**
- Der DNS-Server **nicht erreichbar** ist
- Der DNS-Server **keine Antwort gibt**
- Die **Domain nicht existiert** oder kein passender Record vorhanden ist
- Ein **falscher Record-Typ** abgefragt wird

🟢 **Sensor bleibt grün, wenn:**
- Die DNS-Abfrage erfolgreich war und gültige Daten zurückliefert

## 🔧 Erweiterungsmöglichkeiten
- Weitere DNS-Record-Typen hinzufügen
- Logging aktivieren
- Zusätzliche Fehlerbehandlung

---
**Autor:** Patrick Asmus  
**Lizenz:** MIT  
